	// ===============================================================
	// Global Var
	// ===============================================================
	
	// Edit Handler
	// _______________________________________________________________________
	var EDIT_HANDLER = function(){};	
	EDIT_HANDLER.REF_IS_MODIFIED = false;
	EDIT_HANDLER.HAS_NEWLY_SAVED_DATA = false;
	var PROPERTY_PARENT_ID = 0;
	var PROPERTY_PARENT_DESCRIPTION = "";
	
	
	// Cache
	// _______________________________________________________________________
	var PROPERTY_ACC_ACCESS_ID = null;
	var PROPERTY_ACC_ACCESS_ACC_LEVEL_ID = null;
	var PROPERTY_PARENT_DESCRIPTION = null;
	var PROPERTY_EDIT_MODE = false;
	var PROPERTY_EDIT_ROW_INDEX = -1;
	var INPUT_INSTANCE = null;
	
	
	// Buttons [Optional]
	// _______________________________________________________________________
	var ADD_BBI = null;
	var SAVE_BBI = null;
	var DELETE_BBI = null;
	var CANCEL_BBI = null;
	
	// Dialog Controls [Optional]
	// _______________________________________________________________________
	var PARENT_DESCRIPTION_TXT = null;
	var ACC_ACCESS_SERVER_ID_TXT = null;
	var ACC_ACCESS_SYS_MODULE_ID_CMB = null;
	var ACC_ACCESS_SYS_AUTHORITY_ID_CMB = null;
	var ACC_ACCESS_AUTHORITY_POINT_TXT = null;
	
	
	// DGV Controls
	// _______________________________________________________________________
	var ACCESS_RIGHTS_DGV = null;


	// ===============================================================
	// Initialize Controls
	// ===============================================================     
	function FORM_INITIALIZE()
	{
		// Load Cache Parent Data [Add Redirects if this is a required data.]
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID"))
		{
			PROPERTY_PARENT_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID");
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL;
			//window.close();
		}
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION");
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_PROJECT_DESCRIPTION_TXT") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("REC_PROJECT_DESCRIPTION_TXT", PROPERTY_PARENT_DESCRIPTION);			
			}
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("REC_PROJECT_DESCRIPTION_LBL") == true)
			{
				JSOC_ELEMENT.VAR_VALUE("REC_PROJECT_DESCRIPTION_LBL", PROPERTY_PARENT_DESCRIPTION);			
			}
		}	
		else
		{
			//window.location = JSCUS_CACHE.AUTH_REDIRECT_URL;	
		}
		
 		// Cache Class Properties
		// ...........................................
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_ACC_ACCESS_ID"))
		{
			PROPERTY_ACC_ACCESS_ID = JSVC_COOKIE.VAR_READ("PROPERTY_ACC_ACCESS_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_ID"))
		{
			PROPERTY_ACC_ACCESS_ACC_LEVEL_ID = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_ID");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_PARENT_DESCRIPTION"))
		{
			PROPERTY_PARENT_DESCRIPTION = JSVC_COOKIE.VAR_READ("PROPERTY_PARENT_DESCRIPTION");
		}	
		if(JSVC_COOKIE.VAR_ISSET("PROPERTY_EDIT_MODE"))
		{
			PROPERTY_EDIT_MODE = JSVC_COOKIE.VAR_READ("PROPERTY_ACC_ACCESS_ID");
		}
	
		// Initialize: Modals
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACCESS_RIGHTS_MODAL") == true)
		{
			// Display Modal
			JSOC_DIALOG.VAR_MODAL("ACCESS_RIGHTS_MODAL", false);
		}
				
		// Initialize: Ribbon Buttons
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("EDIT_ACCESS"))
		{
    		ADD_BBI = JSOC_ELEMENT.VAR_GET("EDIT_ACCESS");     	
			
			// Add OnClick event [Show Modal]
			if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("EDIT_ACCESS"))
			{
				ADD_BBI.onclick = 
					function()
					{		
						// Display Modal
						PROPERTY_ACC_ACCESS_ID = 0;
						PROPERTY_EDIT_ROW_INDEX - 1;
						
						if(JSVC_VAR.VAR_ISSET(INPUT_INSTANCE))
						{
							JSOC_WINDOW.VAR_INPUT_INSTANCE_RESTORE(INPUT_INSTANCE);
						}
						JSOC_DIALOG.VAR_MODAL("ACCESS_RIGHTS_MODAL", true);
					}		
			}
			// Add OnClick event [Show Add/Edit Page]
			else
			{
				
			}
		}	
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("SAVE_BBI"))
		{
    		SAVE_BBI = JSOC_ELEMENT.VAR_GET("SAVE_BBI");     
			if(JSVC_VAR.VAR_ISSET(HTTP_SAVE))
			{
				// Prepare Save callback
				var CALLBACK_HANDLER = 
					function(IS_SUCCESS)
					{
						// Abort on failure
						if(IS_SUCCESS == false)
						{
							return;
						}
					
						// Show record saved messageBox
						JSVC_INFO.VAR_RECORD_SAVED('');
					}
				
				// Add OnClick event
				SAVE_BBI.onclick = 
					function()
					{
						HTTP_SAVE(CALLBACK_HANDLER);
					}
			}
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("CANCEL_BBI"))
		{
    		CANCEL_BBI = JSOC_ELEMENT.VAR_GET("CANCEL_BBI");      		
		}
		
		
		// Prepare onChange event
		// ...........................................
		var ON_CHANGE_EVENT = '';
		
		
		// Initialize: Input Controls
		// ...........................................
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("PARENT_DESCRIPTION_TXT"))
		{
    		PARENT_DESCRIPTION_TXT = JSOC_ELEMENT.VAR_GET("PARENT_DESCRIPTION_TXT");      		
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_ACCESS_ID_TXT"))
		{
			ACC_ACCESS_ID_TXT = JSOC_ELEMENT.VAR_GET("ACC_ACCESS_ID_TXT");      
			ACC_ACCESS_ID_TXT.onchange = 
				function()
				{
					if(ACC_ACCESS_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			ACC_ACCESS_ID_TXT.onkeypress = function(){ACC_ACCESS_ID_TXT.onchange();};
			ACC_ACCESS_ID_TXT.onpaste = function(){ACC_ACCESS_ID_TXT.onchange();};
			ACC_ACCESS_ID_TXT.oninput = function(){ACC_ACCESS_ID_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_ACCESS_SERVER_ID_TXT"))
		{
			ACC_ACCESS_SERVER_ID_TXT = JSOC_ELEMENT.VAR_GET("ACC_ACCESS_SERVER_ID_TXT");      
			ACC_ACCESS_SERVER_ID_TXT.onchange = 
				function()
				{
					if(ACC_ACCESS_SERVER_ID_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			ACC_ACCESS_SERVER_ID_TXT.onkeypress = function(){ACC_ACCESS_SERVER_ID_TXT.onchange();};
			ACC_ACCESS_SERVER_ID_TXT.onpaste = function(){ACC_ACCESS_SERVER_ID_TXT.onchange();};
			ACC_ACCESS_SERVER_ID_TXT.oninput = function(){ACC_ACCESS_SERVER_ID_TXT.onchange();};
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_ACCESS_SYS_MODULE_ID_CMB"))
		{
			ACC_ACCESS_SYS_MODULE_ID_CMB = JSOC_ELEMENT.VAR_GET("ACC_ACCESS_SYS_MODULE_ID_CMB");      	
			ACC_ACCESS_SYS_MODULE_ID_CMB.onchange = 
				function()
				{
					if(ACC_ACCESS_SYS_MODULE_ID_CMB.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			ACC_ACCESS_SYS_MODULE_ID_CMB.onkeypress = function(){ACC_ACCESS_SYS_MODULE_ID_CMB.onchange();};
			ACC_ACCESS_SYS_MODULE_ID_CMB.onpaste = function(){ACC_ACCESS_SYS_MODULE_ID_CMB.onchange();};
			ACC_ACCESS_SYS_MODULE_ID_CMB.oninput = function(){ACC_ACCESS_SYS_MODULE_ID_CMB.onchange();};							
		}
		
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB"))
		{
			ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB = JSOC_ELEMENT.VAR_GET("ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB");      	
			ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onchange = 
				function()
				{
					if(ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onkeypress = function(){ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onchange();};
			ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onpaste = function(){ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onchange();};
			ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.oninput = function(){ACC_ACCESS_SYS_AUTHORITY_DESCRIPTION_CMB.onchange();};							
		}
		if(JSOC_ELEMENT.VAR_ELEMENT_EXISTS("ACC_ACCESS_AUTHORITY_POINT_TXT"))
		{
			ACC_ACCESS_AUTHORITY_POINT_TXT = JSOC_ELEMENT.VAR_GET("ACC_ACCESS_AUTHORITY_POINT_TXT");      
			ACC_ACCESS_AUTHORITY_POINT_TXT.onchange = 
				function()
				{
					if(ACC_ACCESS_AUTHORITY_POINT_TXT.disabled == false)
					{
						EDIT_HANDLER.REF_IS_MODIFIED = true;
					}
				};
			ACC_ACCESS_AUTHORITY_POINT_TXT.onkeypress = function(){ACC_ACCESS_AUTHORITY_POINT_TXT.onchange();};
			ACC_ACCESS_AUTHORITY_POINT_TXT.onpaste = function(){ACC_ACCESS_AUTHORITY_POINT_TXT.onchange();};
			ACC_ACCESS_AUTHORITY_POINT_TXT.oninput = function(){ACC_ACCESS_AUTHORITY_POINT_TXT.onchange();};
		}
		
		
		// Initialize: Default Settings
		// ...........................................
		// FORM_PREPARE_DEFAULT_SETTINGS();   	
	}